#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "RingBuff.h"			// CRingBuffg

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pCRingBuffSend = new CRingBuff(SEND_BUFF_SIZE);   // 1.1.MOobt@̍\z
	m_pCRingBuffRecv = new CRingBuff(RECV_BUFF_SIZE);   // 2.1.MOobt@̍\z
	m_pCRingBuffForDistributeChat = new CRingBuff(RECV_BUFF_SIZE);	// 3.1.`bgzMpOobt@̍\z
}

//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	SAFE_DELETE(m_pCRingBuffSend)           // 1.1.MOobt@̔j
	SAFE_DELETE(m_pCRingBuffRecv)           // 2.1.MOobt@̔j
	SAFE_DELETE(m_pCRingBuffForDistributeChat)	// 3.1.`bgzMpOobt@̔j
}

//----------------------------------------------
// function
//    @\Lq֐
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	char	    szRecvBuffer[RCVBUFSIZE];	// Mobt@
	int			iRecvSize;
	pollfd		fds[1] = { 0 };
	char		*pcData = NULL;		// Mf[^
	int			iSendSize = 0;		// Mf[^TCY

	fprintf(stderr, "DoWork()\n");
	fds[0].fd = m_pConInfo->fdClient;
	while (!m_fStopFlag)
	{
		iSendSize = m_pCRingBuffSend->GetReadableSize();    // 1.3.Mf[^邩Oobt@𒲂ׂ
		fds[0].events = POLLIN | POLLRDHUP;					// MƑ葤̐ؒfCxgݒ
		// Mf[^ƂM\
		if (iSendSize > 0)
			fds[0].events |= POLLOUT;						// ݉\ǉ

		poll(fds, 1, 10);
		if (fds[0].revents & POLLRDHUP)			// 葤̐ؒf
		{
			fprintf(stderr, "Disconnected pollrdhup\n");
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLERR)			// G[
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:DoWork");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLIN)			// Mf[^Cxg
		{
			// 2.2.MOobt@ɋ󂫂ΎM
			// ŎMȂ΁AreventsŎMs
			iRecvSize = min(m_pCRingBuffRecv->GetWriteableSize(), RCVBUFSIZE);
			if (iRecvSize > 0)
			{
				if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, iRecvSize, 0)) <= 0)
				{
					m_pConInfo->pCMySyncObject->Lock();
					if (iRecvSize == 0)
						DispErrorMsg("Disconnected recv");
					else
						DispErrorMsg("Err:recv");
					m_pConInfo->pCMySyncObject->UnLock();
					fRet = FALSE;
					break;
				}
				else
				{
					// 2.2.擾f[^ɎMOobt@ɏ
					// MOobt@ɏނ̂͂̃XbhȂ̂ŁAׂď߂͂
					m_pCRingBuffRecv->Write((LPBYTE)szRecvBuffer, iRecvSize);
				}
			}
		}
		// 2.3.MOobt@Ɋi[Ăf[^̉͂s
		// ̃pPbgi[Ă\̂ŁAreventšʂƂ͖֌W
		// ͂s悤ɂ
		if (AnalyzeDataRecv() == -1)
		{
			m_pConInfo->pCMySyncObject->Lock();
			DispErrorMsg("Err:Packet format");
			m_pConInfo->pCMySyncObject->UnLock();
			fRet = FALSE;
			break;
		}
		if (fds[0].revents & POLLOUT)		// M\Ȃsend{
		{
			// 1.3.Mf[^̎擾(PATH_MTU菬Ȃ悤Ɏ擾)
			iSendSize = GetSendData(&pcData);
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)
		}
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
//		MłȂAG[ƂĐؒf̂ǂ
//		͖Ƃ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	// 1.2.MOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = m_pCRingBuffSend->Write((LPBYTE)pcData, iSize);
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	// 1.3.Mf[^邩Oobt@̃f[^TCY𒲂ׂ
	if ((iSize = m_pCRingBuffSend->GetReadableSize()) > 0)
	{
		// MTCYPATH_MTU菬Ă(1024+ʃwb_Ȃv)
		iSize = min(iSize, SENDBUFSIZE);
		*ppcData = (char *)calloc(iSize, sizeof(char));
		iSize = m_pCRingBuffSend->Read((LPBYTE)*ppcData, iSize);
	}
	return(iSize);
}

//----------------------------------------------
// function
//		3.2 `bgbZ[WNCAgɕz邽߂Ɋi[
// parameter
//		char	*pcData	[in]`bgbZ[WpPbg
//		int		iSize	[in]pPbg
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetDataForDistributeChat(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	// 3.2.i[pOobt@ɋ󂫂ȂƂ͏܂Ȃ
	fRet = m_pCRingBuffForDistributeChat->Write((LPBYTE)pcData, iSize);
	return(fRet);
}

//----------------------------------------------
// function
//		3.3.`bgzpf[^̎擾
//		pPbgPʂŎo
//		͂PpPbg
// parameter
//		char **ppcData	[in/out]`bg]pf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetDataForDistributeChat(char **ppcData)
{
	int			iSize = 0, iStoreSize, iPacketSize;
	HeaderRec	Header;

	if ((iStoreSize = m_pCRingBuffForDistributeChat->GetReadableSize()) >= sizeof(HeaderRec))
	{
		// wb_ǂݍ݂
		m_pCRingBuffForDistributeChat->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
		iPacketSize = ntohs(Header.wDataLen) + sizeof(HeaderRec);
		if (iStoreSize >= iPacketSize)
		{
			*ppcData = (char *)calloc(iPacketSize, sizeof(char));
			iSize = m_pCRingBuffForDistributeChat->Read((LPBYTE)*ppcData, iPacketSize);
		}
	}
	return(iSize);
}


//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//	  Mf[^̉
//	  MOobt@Ɋi[Ăf[^𒲂ׂ
// parameter
//	  Ȃ
// retun 2.3.
//	  0:pPbgĂȂ
//	  1:pPbgM̂ŏs
//	  -1:G[
//----------------------------------------------
BOOL CSendRecvThread::AnalyzeDataRecv()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	// 2.3.f[^TCY𒲂ׂ
	int			iSize = m_pCRingBuffRecv->GetReadableSize();

	if (iSize < sizeof(HeaderRec))          // 2.3.wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// 2.3.wb_؂ǂݍ݂
	m_pCRingBuffRecv->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	// wb_̉
	if (memcmp(Header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING)) != 0)
	{
		iRet = -1;							// ʎqႤ̂ŃG[
		goto L_END;
	}
	wCmd = ntohs(Header.wCommand);
	fprintf(stderr, "CMD:%d\n", wCmd);

	switch (wCmd)
	{
		case CMD_MSG_DATA:
			iRet = RecvMessagePacket(&Header);
			break;
		default:						// mȂR}h
			iRet = -1;
			break;
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		bZ[WR}h̎M
// parameter
//		HeaderRec *pHeader	[in]ǂ݂wb_
// return 2.3.
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
BOOL CSendRecvThread::RecvMessagePacket(HeaderRec *pHeader)
{
	int			iRet = 0;
	MsgDataRec	*pMsgData;
	int			iMsgSize, iSize;
	char		*pszMsg = NULL;

	iMsgSize = ntohs(pHeader->wDataLen);
	// 2.3.f[^ȂƂ͉Ȃ
	iSize = m_pCRingBuffRecv->GetReadableSize();
	if (iSize < iMsgSize + sizeof(HeaderRec))
		goto L_END;
	// 2.3.pPbgŜMĂ̂œǂݍ݂{
	pMsgData = (MsgDataRec *)calloc(iMsgSize + sizeof(HeaderRec), sizeof(BYTE));
	m_pCRingBuffRecv->Read((LPBYTE)pMsgData, iMsgSize + sizeof(HeaderRec));
	// NULL^[~l[gǉĊm
	pszMsg = (char *)calloc(iMsgSize + 1, sizeof(char));
	memcpy(pszMsg, pMsgData->bMsgData, iMsgSize);

	// `bgM̂߂ɃbZ[Wf[^pPbgăZbg
	SendMessagePacket(pszMsg, iMsgSize);

	m_pConInfo->pCMySyncObject->Lock();
	fprintf(stderr, "Msg:recv %s\n", pszMsg);
	m_pConInfo->pCMySyncObject->UnLock();

	SAFE_FREE(pMsgData)
	SAFE_FREE(pszMsg)
	iRet = 1;
L_END:
	return(iRet);
}


//----------------------------------------------
// function
//		bZ[WpPbg̑M
//		`bgbZ[WNCAgɓ]邽߂̃GA
//		i[
// parameter
//		char	*pcData		[in]UTF-8f[^(NULL^[~l[gȂ)
//		int		iSize		[in]f[^TCY
// retun
//		Ȃ
//----------------------------------------------
BOOL CSendRecvThread::SendMessagePacket(char *pcData, int iSize)
{
	MsgDataRec	*pMsgData = NULL;
	int			iPacketSize = sizeof(HeaderRec) + iSize;		// pPbgTCY
	BOOL		fRet = FALSE;

	pMsgData = (MsgDataRec *)calloc(iPacketSize, sizeof(BYTE));	// pPbgŜ̃GAm

	memcpy(pMsgData->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pMsgData->header.wCommand = htons(CMD_MSG_DATA);
	pMsgData->header.wDataLen = htons(iSize);

	memcpy(pMsgData->bMsgData, pcData, iSize);
	// 3.2.`bgM̂߂ɃbZ[WpPbgf[^Zbg
	fRet = SetDataForDistributeChat((char *)pMsgData, iPacketSize);

	SAFE_FREE(pMsgData)
	return(fRet);
}
